Backup [velero.io/v1]
- Description
- Backup is a Velero resource that represents the capture of Kubernetes cluster state at a point in time (API objects and associated volume state).
- Type
object
Specification
.spec
- Description
- BackupSpec defines the specification for a Velero backup.
- Type
object
.spec.excludedClusterScopedResources
- Description
- ExcludedClusterScopedResources is a slice of cluster-scoped resource type names to exclude from the backup. If set to "*", all cluster-scoped resource types are excluded. The default value is empty.
- Type
array
.spec.excludedClusterScopedResources[]
- Type
string
.spec.excludedNamespaceScopedResources
- Description
- ExcludedNamespaceScopedResources is a slice of namespace-scoped resource type names to exclude from the backup. If set to "*", all namespace-scoped resource types are excluded. The default value is empty.
- Type
array
.spec.excludedNamespaceScopedResources[]
- Type
string
.spec.excludedNamespaces
- Description
- ExcludedNamespaces contains a list of namespaces that are not included in the backup.
- Type
array
.spec.excludedNamespaces[]
- Type
string
.spec.excludedResources
- Description
- ExcludedResources is a slice of resource names that are not included in the backup.
- Type
array
.spec.excludedResources[]
- Type
string
.spec.hooks
- Description
- Hooks represent custom behaviors that should be executed at different phases of the backup.
- Type
object
.spec.hooks.resources
- Description
- Resources are hooks that should be executed when backing up individual instances of a resource.
- Type
array
.spec.hooks.resources[]
- Description
- BackupResourceHookSpec defines one or more BackupResourceHooks that should be executed based on the rules defined for namespaces, resources, and label selector.
- Type
object- Required
name
.spec.hooks.resources[].excludedNamespaces
- Description
- ExcludedNamespaces specifies the namespaces to which this hook spec does not apply.
- Type
array
.spec.hooks.resources[].excludedNamespaces[]
- Type
string
.spec.hooks.resources[].excludedResources
- Description
- ExcludedResources specifies the resources to which this hook spec does not apply.
- Type
array
.spec.hooks.resources[].excludedResources[]
- Type
string
.spec.hooks.resources[].includedNamespaces
- Description
- IncludedNamespaces specifies the namespaces to which this hook spec applies. If empty, it applies to all namespaces.
- Type
array
.spec.hooks.resources[].includedNamespaces[]
- Type
string
.spec.hooks.resources[].includedResources
- Description
- IncludedResources specifies the resources to which this hook spec applies. If empty, it applies to all resources.
- Type
array
.spec.hooks.resources[].includedResources[]
- Type
string
.spec.hooks.resources[].labelSelector
- Description
- LabelSelector, if specified, filters the resources to which this hook spec applies.
- Type
object
.spec.hooks.resources[].labelSelector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.hooks.resources[].labelSelector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.hooks.resources[].labelSelector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.hooks.resources[].labelSelector.matchExpressions[].values[]
- Type
string
.spec.hooks.resources[].labelSelector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.hooks.resources[].post
- Description
- PostHooks is a list of BackupResourceHooks to execute after storing the item in the backup. These are executed after all "additional items" from item actions are processed.
- Type
array
.spec.hooks.resources[].post[]
- Description
- BackupResourceHook defines a hook for a resource.
- Type
object- Required
exec
.spec.hooks.resources[].post[].exec
- Description
- Exec defines an exec hook.
- Type
object- Required
command
.spec.hooks.resources[].post[].exec.command
- Description
- Command is the command and arguments to execute.
- Type
array
.spec.hooks.resources[].post[].exec.command[]
- Type
string
.spec.hooks.resources[].pre
- Description
- PreHooks is a list of BackupResourceHooks to execute prior to storing the item in the backup. These are executed before any "additional items" from item actions are processed.
- Type
array
.spec.hooks.resources[].pre[]
- Description
- BackupResourceHook defines a hook for a resource.
- Type
object- Required
exec
.spec.hooks.resources[].pre[].exec
- Description
- Exec defines an exec hook.
- Type
object- Required
command
.spec.hooks.resources[].pre[].exec.command
- Description
- Command is the command and arguments to execute.
- Type
array
.spec.hooks.resources[].pre[].exec.command[]
- Type
string
.spec.includedClusterScopedResources
- Description
- IncludedClusterScopedResources is a slice of cluster-scoped resource type names to include in the backup. If set to "*", all cluster-scoped resource types are included. The default value is empty, which means only related cluster-scoped resources are included.
- Type
array
.spec.includedClusterScopedResources[]
- Type
string
.spec.includedNamespaceScopedResources
- Description
- IncludedNamespaceScopedResources is a slice of namespace-scoped resource type names to include in the backup. The default value is "*".
- Type
array
.spec.includedNamespaceScopedResources[]
- Type
string
.spec.includedNamespaces
- Description
- IncludedNamespaces is a slice of namespace names to include objects from. If empty, all namespaces are included.
- Type
array
.spec.includedNamespaces[]
- Type
string
.spec.includedResources
- Description
- IncludedResources is a slice of resource names to include in the backup. If empty, all resources are included.
- Type
array
.spec.includedResources[]
- Type
string
.spec.labelSelector
- Description
- LabelSelector is a metav1.LabelSelector to filter with when adding individual objects to the backup. If empty or nil, all objects are included. Optional.
- Type
object
.spec.labelSelector.matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.labelSelector.matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.labelSelector.matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.labelSelector.matchExpressions[].values[]
- Type
string
.spec.labelSelector.matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.orLabelSelectors
- Description
- OrLabelSelectors is list of metav1.LabelSelector to filter with when adding individual objects to the backup. If multiple provided they will be joined by the OR operator. LabelSelector as well as OrLabelSelectors cannot co-exist in backup request, only one of them can be used.
- Type
array
.spec.orLabelSelectors[]
- Description
- A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.
- Type
object
.spec.orLabelSelectors[].matchExpressions
- Description
- matchExpressions is a list of label selector requirements. The requirements are ANDed.
- Type
array
.spec.orLabelSelectors[].matchExpressions[]
- Description
- A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.
- Type
object- Required
keyoperator
.spec.orLabelSelectors[].matchExpressions[].values
- Description
- values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch.
- Type
array
.spec.orLabelSelectors[].matchExpressions[].values[]
- Type
string
.spec.orLabelSelectors[].matchLabels
- Description
- matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed.
- Type
object
.spec.orderedResources
- Description
- OrderedResources specifies the backup order of resources of specific Kind. The map key is the resource name and value is a list of object names separated by commas. Each resource name has format "namespace/objectname". For cluster resources, simply use "objectname".
- Type
object
.spec.resourcePolicy
- Description
- ResourcePolicy specifies the referenced resource policies that backup should follow
- Type
object- Required
kindname
.spec.uploaderConfig
- Description
- UploaderConfig specifies the configuration for the uploader.
- Type
object
.spec.volumeSnapshotLocations
- Description
- VolumeSnapshotLocations is a list containing names of VolumeSnapshotLocations associated with this backup.
- Type
array
.spec.volumeSnapshotLocations[]
- Type
string
.status
- Description
- BackupStatus captures the current status of a Velero backup.
- Type
object
.status.hookStatus
- Description
- HookStatus contains information about the status of the hooks.
- Type
object
.status.progress
- Description
- Progress contains information about the backup's execution progress. Note that this information is best-effort only -- if Velero fails to update it during a backup for any reason, it may be inaccurate/stale.
- Type
object
.status.validationErrors
- Description
- ValidationErrors is a slice of all validation errors (if applicable).
- Type
array
.status.validationErrors[]
- Type
string
API Endpoints
The following API endpoints are available:
/apis/velero.io/v1/namespaces/{namespace}/backupsDELETE: delete collection of BackupGET: list objects of kind BackupPOST: create a new Backup
/apis/velero.io/v1/namespaces/{namespace}/backups/{name}DELETE: delete the specified BackupGET: read the specified BackupPATCH: partially update the specified BackupPUT: replace the specified Backup
/apis/velero.io/v1/namespaces/{namespace}/backups/{name}/statusGET: read status of the specified BackupPATCH: partially update status of the specified BackupPUT: replace status of the specified Backup
/apis/velero.io/v1/namespaces/{namespace}/backups
- HTTP method
DELETE- Description
- delete collection of Backup
- HTTP responses
- HTTP method
GET- Description
- list objects of kind Backup
- HTTP responses
- HTTP method
POST- Description
- create a new Backup
- Query parameters
- Body parameters
- HTTP responses
/apis/velero.io/v1/namespaces/{namespace}/backups/{name}
- HTTP method
DELETE- Description
- delete the specified Backup
- Query parameters
- HTTP responses
- HTTP method
GET- Description
- read the specified Backup
- HTTP responses
- HTTP method
PATCH- Description
- partially update the specified Backup
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace the specified Backup
- Query parameters
- Body parameters
- HTTP responses
/apis/velero.io/v1/namespaces/{namespace}/backups/{name}/status
- HTTP method
GET- Description
- read status of the specified Backup
- HTTP responses
- HTTP method
PATCH- Description
- partially update status of the specified Backup
- Query parameters
- HTTP responses
- HTTP method
PUT- Description
- replace status of the specified Backup
- Query parameters
- Body parameters
- HTTP responses